/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(VIDEO_TRACK)

#include "JSTextTrackCueList.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSTextTrackCue.h"
#include "TextTrackCue.h"
#include "TextTrackCueList.h"
#include <runtime/Error.h>
#include <runtime/PropertyNameArray.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSTextTrackCueListTableValues[] =
{
    { "length", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextTrackCueListLength), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextTrackCueListConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSTextTrackCueListTable = { 5, 3, true, JSTextTrackCueListTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSTextTrackCueListConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSTextTrackCueListConstructorTable = { 1, 0, false, JSTextTrackCueListConstructorTableValues, 0 };
const ClassInfo JSTextTrackCueListConstructor::s_info = { "TextTrackCueListConstructor", &Base::s_info, &JSTextTrackCueListConstructorTable, 0, CREATE_METHOD_TABLE(JSTextTrackCueListConstructor) };

JSTextTrackCueListConstructor::JSTextTrackCueListConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSTextTrackCueListConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSTextTrackCueListPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSTextTrackCueListConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSTextTrackCueListConstructor, JSDOMWrapper>(exec, JSTextTrackCueListConstructorTable, jsCast<JSTextTrackCueListConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSTextTrackCueListPrototypeTableValues[] =
{
    { "item", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsTextTrackCueListPrototypeFunctionItem), (intptr_t) (1) },
    { "getCueById", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsTextTrackCueListPrototypeFunctionGetCueById), (intptr_t) (1) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSTextTrackCueListPrototypeTable = { 4, 3, false, JSTextTrackCueListPrototypeTableValues, 0 };
const ClassInfo JSTextTrackCueListPrototype::s_info = { "TextTrackCueListPrototype", &Base::s_info, &JSTextTrackCueListPrototypeTable, 0, CREATE_METHOD_TABLE(JSTextTrackCueListPrototype) };

JSObject* JSTextTrackCueListPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSTextTrackCueList>(vm, globalObject);
}

bool JSTextTrackCueListPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSTextTrackCueListPrototype* thisObject = jsCast<JSTextTrackCueListPrototype*>(object);
    return getStaticFunctionSlot<JSObject>(exec, JSTextTrackCueListPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSTextTrackCueList::s_info = { "TextTrackCueList", &Base::s_info, &JSTextTrackCueListTable, 0 , CREATE_METHOD_TABLE(JSTextTrackCueList) };

JSTextTrackCueList::JSTextTrackCueList(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<TextTrackCueList> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSTextTrackCueList::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSTextTrackCueList::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSTextTrackCueListPrototype::create(vm, globalObject, JSTextTrackCueListPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSTextTrackCueList::destroy(JSC::JSCell* cell)
{
    JSTextTrackCueList* thisObject = static_cast<JSTextTrackCueList*>(cell);
    thisObject->JSTextTrackCueList::~JSTextTrackCueList();
}

JSTextTrackCueList::~JSTextTrackCueList()
{
    releaseImplIfNotNull();
}

bool JSTextTrackCueList::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSTextTrackCueList* thisObject = jsCast<JSTextTrackCueList*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    const HashEntry* entry = getStaticValueSlotEntryWithoutCaching<JSTextTrackCueList>(exec, propertyName);
    if (entry) {
        slot.setCustom(thisObject, entry->attributes(), entry->propertyGetter());
        return true;
    }
    unsigned index = propertyName.asIndex();
    if (index != PropertyName::NotAnIndex && index < thisObject->impl().length()) {
        unsigned attributes = DontDelete | ReadOnly;
        slot.setCustomIndex(thisObject, attributes, index, indexGetter);
        return true;
    }
    return getStaticValueSlot<JSTextTrackCueList, Base>(exec, JSTextTrackCueListTable, thisObject, propertyName, slot);
}

bool JSTextTrackCueList::getOwnPropertySlotByIndex(JSObject* object, ExecState* exec, unsigned index, PropertySlot& slot)
{
    JSTextTrackCueList* thisObject = jsCast<JSTextTrackCueList*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    if (index < thisObject->impl().length()) {
        unsigned attributes = DontDelete | ReadOnly;
        slot.setCustomIndex(thisObject, attributes, index, thisObject->indexGetter);
        return true;
    }
    return Base::getOwnPropertySlotByIndex(thisObject, exec, index, slot);
}

EncodedJSValue jsTextTrackCueListLength(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSTextTrackCueList* castedThis = jsDynamicCast<JSTextTrackCueList*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    TextTrackCueList& impl = castedThis->impl();
    JSValue result = jsNumber(impl.length());
    return JSValue::encode(result);
}


EncodedJSValue jsTextTrackCueListConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSTextTrackCueList* domObject = jsDynamicCast<JSTextTrackCueList*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSTextTrackCueList::getConstructor(exec->vm(), domObject->globalObject()));
}

void JSTextTrackCueList::getOwnPropertyNames(JSObject* object, ExecState* exec, PropertyNameArray& propertyNames, EnumerationMode mode)
{
    JSTextTrackCueList* thisObject = jsCast<JSTextTrackCueList*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    for (unsigned i = 0, count = thisObject->impl().length(); i < count; ++i)
        propertyNames.add(Identifier::from(exec, i));
     Base::getOwnPropertyNames(thisObject, exec, propertyNames, mode);
}

JSValue JSTextTrackCueList::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSTextTrackCueListConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

EncodedJSValue JSC_HOST_CALL jsTextTrackCueListPrototypeFunctionItem(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSTextTrackCueList* castedThis = jsDynamicCast<JSTextTrackCueList*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSTextTrackCueList::info());
    TextTrackCueList& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    unsigned index(toUInt32(exec, exec->argument(0), NormalConversion));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.item(index)));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsTextTrackCueListPrototypeFunctionGetCueById(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSTextTrackCueList* castedThis = jsDynamicCast<JSTextTrackCueList*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSTextTrackCueList::info());
    TextTrackCueList& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& id(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.getCueById(id)));
    return JSValue::encode(result);
}


EncodedJSValue JSTextTrackCueList::indexGetter(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue, unsigned index)
{
    JSTextTrackCueList* thisObj = jsCast<JSTextTrackCueList*>(JSValue::decode(slotBase));
    ASSERT_GC_OBJECT_INHERITS(thisObj, info());
    return JSValue::encode(toJS(exec, thisObj->globalObject(), thisObj->impl().item(index)));
}

bool JSTextTrackCueListOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSTextTrackCueListOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSTextTrackCueList* jsTextTrackCueList = jsCast<JSTextTrackCueList*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsTextTrackCueList->impl(), jsTextTrackCueList);
    jsTextTrackCueList->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, TextTrackCueList* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSTextTrackCueList>(exec, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to TextTrackCueList.
    COMPILE_ASSERT(!__is_polymorphic(TextTrackCueList), TextTrackCueList_is_polymorphic_but_idl_claims_not_to_be);
#endif
    ReportMemoryCost<TextTrackCueList>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSTextTrackCueList>(exec, globalObject, impl);
}

TextTrackCueList* toTextTrackCueList(JSC::JSValue value)
{
    return value.inherits(JSTextTrackCueList::info()) ? &jsCast<JSTextTrackCueList*>(value)->impl() : 0;
}

}

#endif // ENABLE(VIDEO_TRACK)
