/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSWebGLTexture.h"

#include "WebGLTexture.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSWebGLTextureTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebGLTextureConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSWebGLTextureTable = { 2, 1, true, JSWebGLTextureTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSWebGLTextureConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSWebGLTextureConstructorTable = { 1, 0, false, JSWebGLTextureConstructorTableValues, 0 };
const ClassInfo JSWebGLTextureConstructor::s_info = { "WebGLTextureConstructor", &Base::s_info, &JSWebGLTextureConstructorTable, 0, CREATE_METHOD_TABLE(JSWebGLTextureConstructor) };

JSWebGLTextureConstructor::JSWebGLTextureConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSWebGLTextureConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSWebGLTexturePrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSWebGLTextureConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSWebGLTextureConstructor, JSDOMWrapper>(exec, JSWebGLTextureConstructorTable, jsCast<JSWebGLTextureConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSWebGLTexturePrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSWebGLTexturePrototypeTable = { 1, 0, false, JSWebGLTexturePrototypeTableValues, 0 };
const ClassInfo JSWebGLTexturePrototype::s_info = { "WebGLTexturePrototype", &Base::s_info, &JSWebGLTexturePrototypeTable, 0, CREATE_METHOD_TABLE(JSWebGLTexturePrototype) };

JSObject* JSWebGLTexturePrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSWebGLTexture>(vm, globalObject);
}

const ClassInfo JSWebGLTexture::s_info = { "WebGLTexture", &Base::s_info, &JSWebGLTextureTable, 0 , CREATE_METHOD_TABLE(JSWebGLTexture) };

JSWebGLTexture::JSWebGLTexture(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<WebGLTexture> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSWebGLTexture::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSWebGLTexture::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSWebGLTexturePrototype::create(vm, globalObject, JSWebGLTexturePrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSWebGLTexture::destroy(JSC::JSCell* cell)
{
    JSWebGLTexture* thisObject = static_cast<JSWebGLTexture*>(cell);
    thisObject->JSWebGLTexture::~JSWebGLTexture();
}

JSWebGLTexture::~JSWebGLTexture()
{
    releaseImplIfNotNull();
}

bool JSWebGLTexture::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSWebGLTexture* thisObject = jsCast<JSWebGLTexture*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSWebGLTexture, Base>(exec, JSWebGLTextureTable, thisObject, propertyName, slot);
}

EncodedJSValue jsWebGLTextureConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSWebGLTexture* domObject = jsDynamicCast<JSWebGLTexture*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSWebGLTexture::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSWebGLTexture::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebGLTextureConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

bool JSWebGLTextureOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSWebGLTextureOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSWebGLTexture* jsWebGLTexture = jsCast<JSWebGLTexture*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsWebGLTexture->impl(), jsWebGLTexture);
    jsWebGLTexture->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebGLTexture@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore12WebGLTextureE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, WebGLTexture* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSWebGLTexture>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7WebGLTexture@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore12WebGLTextureE[2];
#if COMPILER(CLANG)
    // If this fails WebGLTexture does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(WebGLTexture), WebGLTexture_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // WebGLTexture has subclasses. If WebGLTexture has subclasses that get passed
    // to toJS() we currently require WebGLTexture you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<WebGLTexture>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSWebGLTexture>(exec, globalObject, impl);
}

WebGLTexture* toWebGLTexture(JSC::JSValue value)
{
    return value.inherits(JSWebGLTexture::info()) ? &jsCast<JSWebGLTexture*>(value)->impl() : 0;
}

}

#endif // ENABLE(WEBGL)
